/*
 * GigaVoxels - GigaSpace
 *
 * Website: http://gigavoxels.inrialpes.fr/
 *
 * Contributors: GigaVoxels Team
 *
 * BSD 3-Clause License:
 *
 * Copyright (C) 2007-2015 INRIA - LJK (CNRS - Grenoble University), All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the organization nor the names  of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDER BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/** 
 * @version 1.0
 */

///******************************************************************************
// ******************************* INCLUDE SECTION ******************************
// ******************************************************************************/
//
///******************************************************************************
// ****************************** INLINE DEFINITION *****************************
// ******************************************************************************/
//
//namespace GvUtils
//{
//
///******************************************************************************
// * Get the emissive color
// *
// * @return the emissive color
// ******************************************************************************/
//inline const float3& GsMaterial::getKe() const
//{
//	return _Ke;
//}
//
///******************************************************************************
// * Set the emissive color
// *
// * @param pValue the emissive color
// ******************************************************************************/
//inline void GsMaterial::setKe( const float3& pValue )
//{
//	_Ke = pValue;
//}
//
///******************************************************************************
// * Get the ambient color
// *
// * @return the ambient color
// ******************************************************************************/
//inline const float3& GsMaterial::getKa() const
//{
//	return _Ka;
//}
//
///******************************************************************************
// * Set the ambient color
// *
// * @param pValue the ambient color
// ******************************************************************************/
//inline void GsMaterial::setKa( const float3& pValue )
//{
//	_Ka = pValue;
//}
//
///******************************************************************************
// * Get the diffuse color
// *
// * @return the diffuse color
// ******************************************************************************/
//inline const float3& GsMaterial::getKd() const
//{
//	return _Kd;
//}
//
///******************************************************************************
// * Set the diffuse color
// *
// * @param pValue the diffuse color
// ******************************************************************************/
//inline void GsMaterial::setKd( const float3& pValue )
//{
//	_Kd = pValue;
//}
//
///******************************************************************************
// * Get the specular color
// *
// * @return the specular color
// ******************************************************************************/
//inline const float3& GsMaterial::getKs() const
//{
//	return _Ks;
//}
//
///******************************************************************************
// * Set the specular color
// *
// * @param pValue the specular color
// ******************************************************************************/
//inline void GsMaterial::setKs( const float3& pValue )
//{
//	_Ks = pValue;
//}
//
///******************************************************************************
// * Get the shininess color
// *
// * @return the shininess color
// ******************************************************************************/
//inline float GsMaterial::getShininess() const
//{
//	return _shininess;
//}
//
///******************************************************************************
// * Set the shininess color
// *
// * @param pValue the shininess color
// ******************************************************************************/
//inline void GsMaterial::setShininess( float pValue )
//{
//	_shininess = pValue;
//}
//
///******************************************************************************
// * Get the associated device-side object
// *
// * @return the associated device-side object
// ******************************************************************************/
//inline const GsMaterialKernel& GsMaterial::getKernelObject() const
//{
//	return _kernelObject;
//}
//
///******************************************************************************
// * Get the associated device-side object
// *
// * @return the associated device-side object
// ******************************************************************************/
//inline GsMaterialKernel& GsMaterial::editKernelObject()
//{
//	return _kernelObject;
//}
//
//} // namespace GvUtils
